
#if !defined(H_CComMemberObject_H)
	#define H_CComMemberObject_H

namespace ATL
{

template <class Base> //Base must be derived from CComObjectRoot
class CComMemberObject : public Base
{
public:
	typedef Base _BaseClass;
	CComMemberObject() {m_pOuterUnknown = (IUnknown*)0;}
	CComMemberObject(void* pv) {m_pOuterUnknown = (IUnknown*)pv;}

	void SetOuterUnknown(IUnknown *punkContainer) {m_pOuterUnknown = punkContainer;}

#ifdef _ATL_DEBUG_INTERFACES
	~CComMemberObject()
	{
		_Module.DeleteNonAddRefThunk(_GetRawUnknown());
		_Module.DeleteNonAddRefThunk(m_pOuterUnknown);
	}
#endif

	STDMETHOD_(ULONG, AddRef)() {return OuterAddRef();}
	STDMETHOD_(ULONG, Release)() {return OuterRelease();}
	STDMETHOD(QueryInterface)(REFIID iid, void ** ppvObject)
	{	return _InternalQueryInterface(iid, ppvObject);
	}

	template <class Q>
	HRESULT STDMETHODCALLTYPE QueryInterface(Q** pp)
	{
		return QueryInterface(__uuidof(Q), (void**)pp);
	}
	//GetControllingUnknown may be virtual if the Base class has declared
	//DECLARE_GET_CONTROLLING_UNKNOWN()
	IUnknown* GetControllingUnknown()
	{
#ifdef _ATL_DEBUG_INTERFACES
		IUnknown* p;
		_Module.AddNonAddRefThunk(m_pOuterUnknown, _T("CComMemberObject"), &p);
		return p;
#else
		return m_pOuterUnknown;
#endif
	}
};

};

#endif
