// InputSummand.cpp : Implementation of CAdderApp and DLL registration.

#include "stdafx.h"
#include "Adder.h"
#include "InputSummand.h"

#include "StrUtils.h"
#include "MacroUtils.h"

/////////////////////////////////////////////////////////////////////////////
//



// IOTConnector

STDMETHODIMP InputSummand::OpenTool(IOpenTool **a_ppIOpenTool)
{	if (!a_ppIOpenTool)
		return E_POINTER;

	*a_ppIOpenTool=0;

	return GetControllingUnknown()->QueryInterface(IOUT(a_ppIOpenTool));
}

STDMETHODIMP InputSummand::ConnectorType()
{	return e_ConnectorPrimary;
}

// IOTConnectorDescribe

STDMETHODIMP InputSummand::ConnectorName(wchar_t **a_pwsName, wchar_t **a_pwsAliases)
{	if (!a_pwsName || !a_pwsAliases)
		return E_POINTER;

	*a_pwsAliases=0;

	return StrDup(a_pwsName,L"SummandInput");
}

STDMETHODIMP InputSummand::ConnectorDescription(wchar_t **a_pwsDescription)
{	return StrDup(a_pwsDescription,L"One of the two numbers to add up");
}


// IOTInput

HRESULT InputSummand::Compatibility(IOTConnector* a_pIOTConnector)
{	// Let's see if it supports IEgOTDataOptReal or IOTDataVector

	if (!a_pIOTConnector)
		return S_OK;

	CComPtr<IEgOTDataOptReal> t_spIEgOTDataOptReal;
	ONFAILR(a_pIOTConnector->QueryInterface(&t_spIEgOTDataOptReal));

	CComPtr<IOTDataVector> t_spIOTDataVector;
	ONFAILR(a_pIOTConnector->QueryInterface(&t_spIOTDataVector));

	if (!t_spIEgOTDataOptReal && !t_spIOTDataVector)
		return
			e_CompatibilityFailShape	// Data incompatibility (but connection still made anyway)
			|	e_CompatibilityNatureNotRequired
			|	e_CompatibilityPurposeNotSuppliedNorRequired
			|	e_CompatibilityMeaningNotRequired
			|	e_CompatibilityShapeRequired
		;

	return 
			e_CompatibilityPerfect	// OK. Nature, Purpose, & Meaning ignored
			|	e_CompatibilityNatureNotRequired
			|	e_CompatibilityPurposeNotSuppliedNorRequired
			|	e_CompatibilityMeaningNotRequired
			|	e_CompatibilityShapeRequired
		;
}

STDMETHODIMP InputSummand::Connect(IOTConnector* a_pIOTConnector)
{	CComPtr<IOTOutput> t_pIOTOutput;

	if (a_pIOTConnector)	// New input?
		EXPECT(a_pIOTConnector->QueryInterface(&t_pIOTOutput));	// Need it to have an output

	m_spIOTOutputInput=t_pIOTOutput;	// Assign null or new input

	return Compatibility(a_pIOTConnector);
}

STDMETHODIMP InputSummand::Input(IOTConnector** a_ppIOTConnector)
{	if (!a_ppIOTConnector)
		return E_POINTER;

	*a_ppIOTConnector=0;

	if (m_spIOTOutputInput)
		EXPECT(m_spIOTOutputInput->QueryInterface(a_ppIOTConnector));	// Get our input

	return Compatibility(*a_ppIOTConnector);	// compatibilty code
}
