// StubReal.cpp : Implementation of CAdderApp and DLL registration.

#include "stdafx.h"
#include "Adder.h"
#include "StubReal.h"

#include "StrUtils.h"
#include "MacroUtils.h"

/////////////////////////////////////////////////////////////////////////////
//


// IOpenTool

// IOTDescribe
STDMETHODIMP StubReal::Name(wchar_t** a_pwsName, wchar_t** a_pwsAliases)
{	if (!a_pwsName || !a_pwsAliases)
		return E_POINTER;

	*a_pwsAliases=0;

	return StrDup(a_pwsName,L"StubReal");
}


STDMETHODIMP StubReal::Class(wchar_t** a_pwsClass, wchar_t** a_pwsAliases)
{	if (!a_pwsClass || !a_pwsAliases)
		return E_POINTER;

	*a_pwsAliases=0;

	return StrDup(a_pwsClass,L"Number");
}

STDMETHODIMP StubReal::Description(wchar_t** a_pwsDescription)
{	return StrDup(a_pwsDescription,L"Dummy number");
}


// IOTConnector
STDMETHODIMP StubReal::OpenTool(IOpenTool** a_ppIOpenTool)
{	if (!a_ppIOpenTool)
		return E_POINTER;

	*a_ppIOpenTool=0;

	return GetControllingUnknown()->QueryInterface(IOUT(a_ppIOpenTool));
}

STDMETHODIMP StubReal::ConnectorType()
{	return e_ConnectorPrimary;
}

// IOTConnectorDescribe
STDMETHODIMP StubReal::ConnectorName(wchar_t** a_pwsName, wchar_t** a_pwsAliases)
{	if (!a_pwsName || !a_pwsAliases)
		return E_POINTER;

	*a_pwsAliases=0;

	return StrDup(a_pwsName,L"Real");
}

STDMETHODIMP StubReal::ConnectorDescription(wchar_t** a_pwsDescription)
{	return StrDup(a_pwsDescription,L"The number");
}

// IOTOutput

STDMETHODIMP StubReal::Status()
{	return S_OK;
}

STDMETHODIMP StubReal::Changes(index* a_piState)
{	if (a_piState && *a_piState)
		return E_INVALIDARG;	// We only return 0

	return S_OK;	// Never any change
}

// IOTDataVector

STDMETHODIMP StubReal::Nature()
{	return S_OK;
}

STDMETHODIMP StubReal::Vector(real *a_prBuffer, unsigned a_uBufferLength, index* a_piStart, unsigned* a_puReturned,index* a_piRemain)
{	if (!a_piStart || !a_puReturned || !a_piRemain)
		return E_POINTER;

	if (a_prBuffer && a_uBufferLength && !*a_piStart)	// Were we given a buffer and asked for the zeroth real?
	{	a_prBuffer[0]=4.5;	// Return the number
		*a_puReturned=1U;	// 1 off
		*a_piRemain=0;		// None left
	}
	else
	{	*a_puReturned=0;	// Couldn't return anything
		*a_piRemain=1UL;	// 1 real left
	}

	*a_piStart=0;			// 0 is always position of next real (non-zero or otherwise)

	return S_OK;
}

// IEgOTDataOptReal

STDMETHODIMP StubReal::EgOptNature()
{	return S_OK;
}

STDMETHODIMP StubReal::EgOptReal(real *a_prValue)
{	if (!a_prValue)
		return E_UNEXPECTED;	// MIDL should have allocated a_pReal

	*a_prValue=4.5;

	return S_OK;
}

