// TrivialAdder.h: Definition of the TrivialAdder class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRIVIALADDER_H__C8F1529E_BCAC_414E_966A_A3D4C4E7D214__INCLUDED_)
#define AFX_TRIVIALADDER_H__C8F1529E_BCAC_414E_966A_A3D4C4E7D214__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // main symbols

#include "DebugRefCount.h"

#include "CComMemberObject.h"	// Strangely missing from ATL

#include "InputSummand.h"	// Our input connectors
#include "OutputSum.h"		// Our output connector


/////////////////////////////////////////////////////////////////////////////
// TrivialAdder - adds two numbers together




class TrivialAdder : 
	public IOpenTool,
	public IOTDescribe,
	public IOTChain,
	public IEnumUnknown,
	public CComObjectRoot,
	public CComCoClass<TrivialAdder,&CLSID_TrivialAdder>
{
public:
	typedef CComEnum<IEnumUnknown, &IID_IEnumUnknown, IUnknown*, _CopyInterface<IUnknown> >	 tEnum;

BEGIN_COM_MAP(TrivialAdder)
	COM_INTERFACE_ENTRY(IOpenTool)
	COM_INTERFACE_ENTRY(IOTDescribe)
	COM_INTERFACE_ENTRY(IOTChain)
	COM_INTERFACE_ENTRY(IEnumUnknown)
	COM_INTERFACE_ENTRY_AGGREGATE_BLIND(m_spIUnknownOutputSum.p)	// We also expose out primary output's connector on the Open Tool interface
END_COM_MAP()

DECLARE_REGISTRY_RESOURCEID(IDR_TrivialAdder)
DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_PROTECT_FINAL_CONSTRUCT()

_DEBUG_REFCOUNT_IMPL(TrivialAdder,CComSingleThreadModel)

	HRESULT FinalConstruct();
	void FinalRelease();

private:
	CComMemberObject<InputSummand> m_InputSummand1;	// Hook in input connectors
	CComMemberObject<InputSummand> m_InputSummand2;
	CComPtr<IUnknown> m_spIUnknownOutputSum;	// Our output connector is also aggregated by the Open Tool

	CComObject<tEnum>* m_pEnumConnectors;	// Pointer to our enumerator of connectors

	IUnknown* m_apIUnknown[3];	// A list of our connectors
	
protected:

public:
	TrivialAdder():m_pEnumConnectors(0) { }

public:	// COM Stuff
// IOpenTool

// IOTDescribe
	STDMETHOD(Name)(/*[out,string]*/ wchar_t** a_pwsName,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(Class)(/*[out,string]*/ wchar_t** a_pwsClass,/*[out,string]*/ wchar_t** a_pwsAliases);
	STDMETHOD(Description)(/*[out,string]*/ wchar_t** a_pwsDescription);

// IOTChain
	HRESULT ChainInOutput(IUnknown* a_pIUnknown);	// Internal method

	STDMETHOD(ChainIn)(IOpenTool* a_pIOpenTool);	// Plug in as many of its outputs into our outputs as possible
	STDMETHOD(Remove)(IOpenTool* a_pIOpenTool);		// Remove this tool (disconnect any outputs obtained from this tool)
	STDMETHOD(RemoveAll)();							// Remove all chained tools
	STDMETHOD(Enum)(/*[out,ref]*/ IEnumUnknown** a_ppIEnumUnknown);	// Provide a snapshot of the list of the tools currently chained-in

// IEnumUnknown
    STDMETHOD(Next)(/* [in] */ ULONG celt,/* [out] */ IUnknown __RPC_FAR *__RPC_FAR *rgelt,/* [out] */ ULONG __RPC_FAR *pceltFetched);
	STDMETHOD(Skip)(/* [in] */ ULONG celt);
	STDMETHOD(Reset)( void);
    STDMETHOD(Clone)(/* [out] */ IEnumUnknown __RPC_FAR *__RPC_FAR *ppenum);

};

#endif // !defined(AFX_TRIVIALADDER_H__C8F1529E_BCAC_414E_966A_A3D4C4E7D214__INCLUDED_)
